#include<bits/stdc++.h>

#define int long long
#define pb push_back
#define ld long double

using namespace std;

const int MOD = 1e9;
deque<pair<int,int>> q;

void add(int i, int val) {
    while (q.size() > 0 && val > q.back().first) {
        q.pop_back();
    }
    q.pb({val, i});
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, f;
    cin >> n >> f;
    vector<int> d(n);
    if (f == 1) {
        for (int i = 0; i < n; i++) {
            cin >> d[i];
        }
    } else {
        int m, x, y, z;
        cin >> m >> x >> y >> z;
        vector<int> c(m);
        for (int i = 0; i < m; i++) {
            cin >> c[i];
        }
        for (int i = 0; i < n; i++) {
            if (i < m) d[i] = c[i];
            else d[i] = (x * d[i - 2] + y * d[i - 1] + z) % MOD + 1;
        }
    }
    int bal = 0;
    for (int i = 1; i < n; i++) {
        add(i, d[i] - i + 1);
    }
    pair<int,int> p{MOD, MOD};
    for (int i = 0; i < n; i++) {
        int need = 0, mx = 0;
        for (int j = 0; j < n - 1; j++) {
            mx = max(mx, d[(j + i) % n] - need);
            need++;
        }
        if (mx < p.first) {
            p = {mx, i};
        }
    }
    cout << p.first << ' ' << p.second + 1 << endl;
    return 0;
}
