#include<bits/stdc++.h>

#define int long long
#define pb push_back
#define ld long double

using namespace std;

const ld eps = 0.00000001;

struct point {
    ld x, y;
};

struct triangle {
    point a, b, c, ab, bc, ca;
};

point sub(point a, point b) {
    return {a.x - b.x, a.y - b.y};
}

point rev(point a) {
    return {-a.x, -a.y};
}

ld len(point a) {
    return sqrt(a.x * a.x + a.y * a.y);
}

ld get(ld ab, ld bc, ld ca) {
    ld p = (ld)(ab + bc + ca) / 2.0, res = 0;
    res = sqrt(p);
    res *= sqrt(p - ab);
    res *= sqrt(p - bc);
    res *= sqrt(p - ca);
    return res;
}

bool cmp(point a, point b) {
    return (a.x == b.x && a.y == b.y);
}

const int N = 100;

vector<vector<int>> ans;
vector<bool> used(N);
vector<int> now;
vector<ld> arr;
vector<triangle> a(N);
int t, n;

void rec(int i) {
    if (i == 4) {
        ld sum = 0;
        for (auto to : now) {
            sum += get(len(a[to].ab), len(a[to].bc), len(a[to].ca));
        }
        ld my = get(arr[1] + arr[2], arr[3] + arr[4], arr[0] + arr[5]);
        if (abs(my - sum) < eps) {
            ans.pb(now);
        }
        return;
    }
    point need;
    if (i == 1) need = a[now[0]].ab;
    else if (i == 2) need = a[now[0]].bc;
    else if (i == 3) need = a[now[0]].ca;
    for (int j = 0; j < n; j++) {
        if (!used[j]) {
            if (cmp(a[j].ab, need)) {
                arr.pb(len(a[j].ca));
                arr.pb(len(a[j].bc));
                used[j] = 1;
                now.pb(j);
                rec(i + 1);
                arr.pop_back();
                arr.pop_back();
                used[j] = 0;
                now.pop_back();
            }
            if (cmp(rev(a[j].ab), need)) {
                arr.pb(len(a[j].bc));
                arr.pb(len(a[j].ca));
                used[j] = 1;
                now.pb(j);
                rec(i + 1);
                arr.pop_back();
                arr.pop_back();
                used[j] = 0;
                now.pop_back();
            }
            if (cmp(a[j].bc, need)) {
                arr.pb(len(a[j].ab));
                arr.pb(len(a[j].ca));
                used[j] = 1;
                now.pb(j);
                rec(i + 1);
                arr.pop_back();
                arr.pop_back();
                used[j] = 0;
                now.pop_back();
            }
            if (cmp(rev(a[j].bc), need)) {
                arr.pb(len(a[j].ca));
                arr.pb(len(a[j].ab));
                used[j] = 1;
                now.pb(j);
                rec(i + 1);
                arr.pop_back();
                arr.pop_back();
                used[j] = 0;
                now.pop_back();
            }
            if (cmp(a[j].ca, need)) {
                arr.pb(len(a[j].bc));
                arr.pb(len(a[j].ab));
                used[j] = 1;
                now.pb(j);
                rec(i + 1);
                arr.pop_back();
                arr.pop_back();
                used[j] = 0;
                now.pop_back();
            }
            if (cmp(rev(a[j].ca), need)) {
                arr.pb(len(a[j].ab));
                arr.pb(len(a[j].bc));
                used[j] = 1;
                now.pb(j);
                rec(i + 1);
                arr.pop_back();
                arr.pop_back();
                used[j] = 0;
                now.pop_back();
            }
        }
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> t >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i].a.x >> a[i].a.y >> a[i].b.x >> a[i].b.y >> a[i].c.x >> a[i].c.y;
        a[i].ab = sub(a[i].b, a[i].a);
        a[i].bc = sub(a[i].c, a[i].b);
        a[i].ca = sub(a[i].a, a[i].c);
    }
    for (int i = 0; i < n; i++) {
        now.pb(i);
        used[i] = 1;
        rec(1);
        used[i] = 0;
        now.pop_back();
    }
    for (int i = 0; i < ans.size(); i++) {
        sort(ans[i].begin(), ans[i].end());
    }
    map<vector<int>, int> was;
    vector<vector<int>> show;
    for (auto to : ans) {
        if (was[to]) continue;
        was[to] = 1;
        show.pb(to);
    }
    cout << show.size() << endl;
    for (auto to : show) {
        cout << to[0] + 1 << ' ' << to[1] + 1 << ' ' << to[2] + 1 << ' ' << to[3] + 1 << endl;
    }
    return 0;
}
