#include<bits/stdc++.h>

#define int long long
#define pb push_back
#define ld long double

using namespace std;

vector<int> sum(vector<int> a, vector<int> b) {
    vector<int> c(a.size());
    for (int i = 0; i < a.size(); i++) {
        c[i] = a[i] + b[i];
    }
    return c;
}

bool is_palindrom(vector<int> a) {
    int n = a.size();
    for (int i = 0; i < n; i++) {
        if (a[i] != a[n - i - 1]) {
            return 0;
        }
    }
    return 1;
}

int solve(int n, int m, vector<int> a, vector<int> b) {
    for (int k = min(n, m); k >= 1; k--) {
        vector<vector<int>> A, B;
        for (int i = 0; i + k <= n; i++) {
            A.pb(vector<int>{a.begin() + i, a.begin() + i + k});
        }
        for (int i = 0; i + k <= m; i++) {
            B.pb(vector<int>{b.begin() + i, b.begin() + i + k});
        }
        for (auto to1 : A) {
            for (auto to2 : B) {
                if (is_palindrom(sum(to1, to2))) {
                    return k;
                }
            }
        }
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    cout << solve(n, m, a, b) << endl;
    return 0;
}
